    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * PlumNeedle.java
    029     * ---------------
    030     * (C) Copyright 2002-2006, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: PlumNeedle.java,v 1.4.2.3 2006/08/02 10:40:57 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 27-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.needle;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.geom.Arc2D;
    051    import java.awt.geom.Area;
    052    import java.awt.geom.Point2D;
    053    import java.awt.geom.Rectangle2D;
    054    import java.io.Serializable;
    055
    056    /**
    057     * A needle for use with the {@link org.jfree.chart.plot.CompassPlot} class.
    058     */
    059    public class PlumNeedle extends MeterNeedle
    060                            implements Cloneable, Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = -3082660488660600718L;
    064
    065        /**
    066         * Draws the needle.
    067         *
    068         * @param g2  the graphics device.
    069         * @param plotArea  the plot area.
    070         * @param rotate  the rotation point.
    071         * @param angle  the angle.
    072         */
    073        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    074                                  Point2D rotate, double angle) {
    075
    076            Arc2D shape = new Arc2D.Double(Arc2D.PIE);
    077            double radius = plotArea.getHeight();
    078            double halfX = plotArea.getWidth() / 2;
    079            double diameter = 2 * radius;
    080
    081            shape.setFrame(plotArea.getMinX() + halfX - radius ,
    082                           plotArea.getMinY() - radius,
    083                           diameter, diameter);
    084            radius = Math.toDegrees(Math.asin(halfX / radius));
    085            shape.setAngleStart(270 - radius);
    086            shape.setAngleExtent(2 * radius);
    087
    088            Area s = new Area(shape);
    089
    090            if ((rotate != null) && (angle != 0)) {
    091                /// we have rotation houston, please spin me
    092                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    093                s.transform(getTransform());
    094            }
    095
    096            defaultDisplay(g2, s);
    097        }
    098
    099        /**
    100         * Tests another object for equality with this object.
    101         *
    102         * @param obj  the object to test (<code>null</code> permitted).
    103         *
    104         * @return A boolean.
    105         */
    106        public boolean equals(Object obj) {
    107            if (obj == this) {
    108                return true;
    109            }
    110            if (!(obj instanceof PlumNeedle)) {
    111                return false;
    112            }
    113            if (!super.equals(obj)) {
    114                return false;
    115            }
    116            return true;
    117        }
    118
    119        /**
    120         * Returns a clone of this needle.
    121         *
    122         * @return A clone.
    123         *
    124         * @throws CloneNotSupportedException if the <code>PlumNeedle</code>
    125         *     cannot be cloned (in theory, this should not happen).
    126         */
    127        public Object clone() throws CloneNotSupportedException {
    128            return super.clone();
    129        }
    130
    131    }